/*
Goto NoRexx
*/

/*****************************************************************************\
 *              Install.cmd  NPS WPS installation batch file                 *
 *                          By Jacco de Leeuw                                *
 *                                                                           *
 *           REXX Code was taken from various sources, such as               *
 * PC/2 Install.cmd: Copyright (C) by Stangl Roman, 1993, 1994, 1995         *
 * FM/2 Install.cmd: Copyright (C) 1993/94 by M. Kimes (Bare Bones Software) *
 *    As far as I am concerned, you can do with it whatever your want...     *
\*****************************************************************************/

/* I wouldn't edit this with an editor that converts TABs to spaces,
   such as EPM 5.x and TEDIT
*/

Main:

'@Echo off'
Call On Halt Name GoodBye
Parse Source Source.1 Source.2 Source.3;

Call Initialize_AndAskLanguage;
Call SetupLanguageStrings;
Call CheckRunningOrIncomplete;
Call SetupDestinationDir;
Call CreateObjects;
Call CompileRC_AndFinish;
Call GoodBye 1;
Exit;

/*--------------------------------------------------------------------------------------*\
 * Show the startup screen and ask the user which language he or she prefers.           *
 *                                                                                      *
\*--------------------------------------------------------------------------------------*/

Initialize_AndAskLanguage:

/* load rexx utility functions */
Call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
Call SysLoadFuncs

Esc=d2c(27)d2c(91);
Hig=esc'1m';
LRed=Hig||esc'31m';
LGre=Hig||esc'32m';
LWhi=Hig||esc'37m';
BBlu=esc'44m';
Say LWhi||BBlu'Abcd';       /* Set highlighted white on blue */

NPSBase.1=13;
NPSBase.2= "npsnwa01.dll";
NPSBase.3= "npswpscb.bmp";
NPSBase.4= "npswa01.doc";
NPSBase.5= "npswps.dat";
NPSBase.6= "npswps.dll";
NPSBase.7= "npswps.exe";
NPSBase.8= "npswps.ini";
NPSBase.9= "npswps.rc";
NPSBase.10="npswpsri.dll";
NPSBase.11="npswpsri.rc";
NPSBase.12="npswpswa.doc";
NPSBase.13="npswpswa.dll";

cr='0d'x;
crlf='0d0a'x;
/* Remember the path from which the user executed the INSTALL */
InvokeDir=Directory();
/* Get the full path of INSTALL.CMD (may be diff. than InvokeDir! */
SourceDir=FileSpec('Drive',Source.3)||FileSpec('Path',Source.3);
/* Drop the trailing \. Otherwise we can't change to it(!) */
SourceDir=Strip(SourceDir,"T","\");
SourceDir=Directory(SourceDir);

Do Until (Language="E" | Language="J" | Language="D" | Language="N" | Language='I' | Language='F' | Language='S' | Language="Q")

        Call Banner;
        Say " "LGre"D"LWhi" ... Installation, Programm und Anleitung auf Deutsch";
        Say " "LGre"E"LWhi" ... Installation, program and documentation in English";
        Say " "LGre"F"LWhi" ... Installation, programme et documentation en Franais";
        Say " "LGre"I"LWhi" ... Installazione, programma e documentazione in Italiano";

        Say " "LGre"J"LWhi" ... Installation and documentation in English, program in Japanese";

        Say " "LGre"N"LWhi" ... Installatie, programma en documentatie in het Nederlands";

        Say " "LGre"S"LWhi" ... Asennus, ohjelma ja dokumentaatio Suomen kielell";

        Say " "LGre"Q"LWhi" ... Quit / Exit / Stop";
        Say;
        Call charout ,"Please type the key of your choice / Drcken Sie die Taste Ihrer Wahl /",
                        crlf"Type de toets van uw keuze / Paina nppint: "LGre;
        Language=getUserInput("DEFIJNSQ")
        If (Language='Q') Then Call GoodBye 0
End;
Return;

/*--------------------------------------------------------------------------------------*\
 *  Returns a character, must be in the list of valid characters.                       *
 *                                                                                      *
\*--------------------------------------------------------------------------------------*/

getUserInput:
Parse Arg validKeys
done=0;
Do While done <> 1
        key = SysGetKey('NOECHO')
        If DATATYPE(key, 'A') then
        Do
                key = VALUE(key); /* convert to upper case */
                If verify(key, validKeys) = 0 Then Done = 1
        End
End
Say
Return key

/*--------------------------------------------------------------------------------------*\
 *  Print NPS WPS banner                                                                *
 *                                                                                      *
\*--------------------------------------------------------------------------------------*/
Banner:
'Cls'
Say LRed;
Say"     Ŀ";
Say"                       "LWhi"NPS WPS Installation Script"LRed"                      ";
Say"              "LWhi"Copyright (c) 1995,1996 by Shinji "N.P.S." Takasugi"LRed"         ";
Say"     "LWhi;
Say;
Return;

/*--------------------------------------------------------------------------------------*\
 * Setup some language dependent strings which can be used later in the program.        *
 *                                                                                      *
\*--------------------------------------------------------------------------------------*/

SetupLanguageStrings:

Select

/*-----------------Start German translation strings------------------------------------*/
When (Language="D") Then
        Do
        YES='J';
        NO='N';
        CANNOTSTARTNPS= "Kann NPS WPS nicht starten!";
        CREATING=       "NPS WPS Ordner und Objekte werden erstellt...";
        FILENOTFOUND=   "NPSWPS.EXE nicht gefunden! Sind die Installationsdateien "||,
                        "vollstndig?"crlf"Versuchen Sie INSTALL.CMD im Verzeichnis "||,
                        "mit den Installationsdateien"crlf"zu starten.";
        TITLE1=         "NPS WPS Enhancer";
        TITLE2=         "NPS WPS"crlf"Anleitung";
        TITLE3=         "Anleitung fr"crlf"Fensteranimationen";
        TITLE4=         "NPS WPS lschen";
        FILE1=          "LiesMich.1st";
        FILE2=          "NPSWPSDE";
        NPSFOUND=       "Der NPS WPS Ordner besteht schon."crlf||,
                        crlf"Solange Sie selbst noch keine Objekte in diesem Ordner erstellt "||,
                        "haben,"crlf"knnen Sie problemlos diesen Ordner lschen und einen "||,
                        "neuen Ordner erstellen"crlf"(z.B. wenn Sie eine andere Sprache "||,
                        "whlen oder die NPS WPS Objekte neu"crlf"erstellen wollen)."crlf||,
                        crlf"Diesen Ordner lschen und einen neuen Ordner erstellen? (J/N):";
        RUNNING=        "NPS WPS ist schon aktiv! Sie mssen NPS WPS erst beenden "||,
                        "und "crlf"danach INSTALL.CMD erneut starten.";
        ASKDIR=         "NPS WPS mu in einem Verzeichnis installiert werden."crlf||,
                        "Es gibt zwei Mglichkeiten:"crlf||crlf||,
                        "- Sie installieren von Diskette oder CD-ROM auf die Festplatte."||,
                        " Oder Sie haben"crlf"  NPSWPS.ZIP in einem temporren Verzeichnis "||,
                        "ausgepackt und wollen NPSWPS.ZIP"crlf"  aus einem anderen "||,
                        "Verzeichnis heraus arbeiten lassen. Dann mssen die"crlf||,
                        "Installationsdateien kopiert werden. Dazu geben Sie den "||,
                        "vollstndigen"crlf"  Pfadnamen des gewnschten Verzeichnisses ein "||,
                        "(z.B. "LGre"C:\NPSWPS"LWhi")."||,
                        " Besteht"crlf"  dieses Verzeichnis noch nicht, so wird es fr "||,
                        "Sie erstellt."crlf||crlf||,
                        "- Sie haben NPSWPS.ZIP bereits im Zielverzeichnis Ihrer Wahl auf "||,
                        "der"crlf"  Festplatte ausgepackt. Geben Sie dann kein Verzeichnis "||,
                        "ein,"crlf"  sondern"LGre" drcken Sie nur auf "LGre"Return."||LWhi||,
                        crlf||crlf"Zum Abbrechen des Vorgangs drcken Sie die Tasten Strg-C und dann Enter .";
        PROMPTDIR=      "Geben Sie das Zielverzeichnis ein:";
        NOCREATEDIR=    ": Verzeichnis wird nicht erstellt. REXX: SysMkDir Fehlerkode =";
        COPYFAILED=     "Dateien werden nicht kopiert. OS/2: Fehlerkode =";
        PRESSANYKEY="Drcke Sie eine Taste";
        End;
/*-------------------End German translation strings------------------------------------*/

/*-------------------Start Dutch translation strings------------------------------------*/
When (Language="N") Then
        Do
        YES='J';
        NO='N';
        CANNOTSTARTNPS= "Kan NPS WPS niet starten!";
        CREATING=       "NPS WPS Map en objecten worden gecreerd...";
        FILENOTFOUND=   "NPSWPS.EXE niet gevonden! Zijn de installatiebestanden wel "||,
                        "compleet?"crlf"Probeer INSTALL.CMD anders op te starten vanuit de "||,
                        "directory met de"crlf"installatiebestanden.";
        TITLE1=         "NPS WPS Enhancer";
        TITLE2=         "NPS WPS"crlf"Handleiding";
        TITLE3=         "Documentatie voor"crlf"vensteranimaties";
        TITLE4=         "NPS WPS verwijderen";
        FILE1=          "LeesMij.1st";
        FILE2=          "NPSWPSNL";
        NPSFOUND=       "De NPS WPS map bestaat al."crlf||,
                        crlf"Zolang u zelf geen objecten in deze map hebt aangemaakt kan "||,
                        "het geen kwaad"crlf"om deze map te wissen en een nieuwe aan te maken"||,
                        " (bijvoorbeeld als u een"crlf"andere taal wilt gebruiken, of de NPS "||,
                        "WPS objecten opnieuw wilt aanmaken)."crlf||,
                        crlf"Zal ik de map wissen en een nieuwe maken? (J/N):";
        RUNNING=        "NPS WPS draait momenteel al! U dient NPS WPS eerst af "||,
                        "te sluiten"crlf"en daarna INSTALL.CMD opnieuw op te starten.";
        ASKDIR=         "NPS WPS moet in een directory genstalleerd worden."||,
                        "Er zijn twee mogelijkheden:"crlf||crlf||,
                        "- U installeert vanaf diskette of CD-ROM naar de harddisk."crlf||,
                        "  Of u heeft NPSWPS.ZIP uitgepakt naar een tijdelijke directory"||,
                        " en wilt"crlf"  NPS WPS gebruiken vanuit een andere directory. De "||,
                        "bestanden zullen dan"crlf"  overgekopieerd worden. Voert u dan het "||,
                        "volledige pad in van de directory in"crlf"  die u wilt gebruiken. "||,
                        "(Als deze directory nog niet bestaat, wordt deze"crlf"  voor u"||,
                        " aangemaakt). Voorbeeld: "LGre"C:\NPSWPS"LWhi||crlf||crlf||,
                        "- U heeft NPSWPS.ZIP al uitgepakt naar de directory op de harddisk"||,
                        crlf"  van waaruit u NPS WPS wilt gaan gebruiken."crlf"  Voert u dan "||,
                        "geen directory in maar "LGre"druk enkel op Return."||LWhi||crlf||,
                        crlf"Wilt u stoppen, druk dan op Ctrl-C, gevolgd door Enter.";
        PROMPTDIR=      "Voer doeldirectory in:";
        NOCREATEDIR=    ": Kan directory niet aanmaken. REXX: SysMkDir foutcode=";
        COPYFAILED=     "Kan bestanden niet kopiren. OS/2: foutcode=";
        PRESSANYKEY=    "Druk een toets";
        End;

/*--------------------End Dutch translation strings------------------------------------*/

/*-----------------Start Italian translation strings------------------------------------*/
When (Language="I") Then
        Do
        YES='S';
        NO='N';
        CANNOTSTARTNPS= "Cannot start NPS WPS!";
        CREATING=       "Creating NPS WPS folder and objects...";
        FILENOTFOUND=   "NPSWPS.EXE not found! Are the installation files complete?"||,
                        " Otherwise, you could"crlf"try to run INSTALL.CMD from the"||,
                        " directory with the installation files.";
        TITLE1=         "NPS WPS Enhancer";
        TITLE2=         "NPS WPS"crlf"Documentazione";
        TITLE3=         "Documentazione"crlf"per le animazioni finestre";
        TITLE4=         "Deinstallazione"crlf"NPS WPS";
        FILE1=          "Leggimi.Ora";
        FILE2=          "NPSWPSIT";
        NPSFOUND=       "The NPS WPS folder does already exist."crlf||,
                        crlf"As long as you haven't created any objects in this folder, "||,
                        "it's safe to delete"crlf"this folder and rebuild a new one (for"||,
                        " instance, if you want to use another"crlf"language or just want to "||,
                        "create the NPS WPS objects again)."crlf||,
                        crlf"Shall I delete the folder and make a new one? (S/N):";
        RUNNING=        "NPS WPS is already running at the moment! You have to close "||,
                        "NPS WPS first,"crlf"and then execute INSTALL.CMD again.";
        ASKDIR=         "NPS WPS is going to be installed to a directory. "||,
                        "Two situations are possible:"crlf||crlf||,
                        "- You are installing from diskette or CD-ROM to the harddisk."crlf||,
                        "  Or you have unzipped NPSWPS.ZIP to a temporary directory and wish"||,
                        " to use"crlf"  NPS WPS from another directory. The files will be "||,
                        "copied. Then please enter"crlf"  the full path to the directory "||,
                        "that you would like to use."crlf"  (If this directory doesn't exist "||,
                        "yet, it will be created)."crlf||,
                        "  Example: "LGre"C:\NPSWPS"LWhi||crlf||crlf||,
                        "- You have unzipped NPSWPS.ZIP to the directory on the harddisk "||,
                        "from which"crlf"  you want to use NPS WPS."||,
                        " Then don't enter a directory, but just "LGre"press Enter."||LWhi||,
                        crlf||crlf"Would you like to quit, press Ctrl-C, followed by Enter.";
        PROMPTDIR=      "Please enter destination directory:";
        NOCREATEDIR=    ": Could not create directory. REXX: SysMkDir errorcode=";
        COPYFAILED=     "Could not copy files. OS/2 error code=";
        PRESSANYKEY=    "Press any key";
        End;
/*-------------------End Italian translation strings------------------------------------*/

/*------------------Start French translation strings------------------------------------*/
When (Language="F") Then
        Do
        YES='O';
        NO='N';
        CANNOTSTARTNPS= "Cannot start NPS WPS!";
        CREATING=       "Creating NPS WPS folder and objects...";
        FILENOTFOUND=   "NPSWPS.EXE not found! Are the installation files complete?"||,
                        " Otherwise, you could"crlf"try to run INSTALL.CMD from the"||,
                        " directory with the installation files.";
        TITLE1=         "NPS WPS Enhancer";
        TITLE2=         "NPS WPS"crlf"Documentation";
        TITLE3=         "Documentation"crlf"sur l'animer des fentres";
        TITLE4=         "Uninstall NPS WPS";
        FILE1=          "Lisez.Moi";
        FILE2=          "NPSWPSFR";
        NPSFOUND=       "The NPS WPS folder does already exist."crlf||,
                        crlf"As long as you haven't created any objects in this folder, "||,
                        "it's safe to delete"crlf"this folder and rebuild a new one (for"||,
                        " instance, if you want to use another"crlf"language or just want to "||,
                        "create the NPS WPS objects again)."crlf||,
                        crlf"Shall I delete the folder and make a new one? (O/N):";
        RUNNING=        "NPS WPS is already running at the moment! You have to close "||,
                        "NPS WPS first,"crlf"and then execute INSTALL.CMD again.";
        ASKDIR=         "NPS WPS is going to be installed to a directory. "||,
                        "Two situations are possible:"crlf||crlf||,
                        "- You are installing from diskette or CD-ROM to the harddisk."crlf||,
                        "  Or you have unzipped NPSWPS.ZIP to a temporary directory and wish"||,
                        " to use"crlf"  NPS WPS from another directory. The files will be "||,
                        "copied. Then please enter"crlf"  the full path to the directory "||,
                        "that you would like to use."crlf"  (If this directory doesn't exist "||,
                        "yet, it will be created)."crlf||,
                        "  Example: "LGre"C:\NPSWPS"LWhi||crlf||crlf||,
                        "- You have unzipped NPSWPS.ZIP to the directory on the harddisk "||,
                        "from which"crlf"  you want to use NPS WPS."||,
                        " Then don't enter a directory, but just "LGre"press Enter."||LWhi||,
                        crlf||crlf"Would you like to quit, press Ctrl-C, followed by Enter.";
        PROMPTDIR=      "Please enter destination directory:";
        NOCREATEDIR=    ": Could not create directory. REXX: SysMkDir errorcode=";
        COPYFAILED=     "Could not copy files. OS/2 error code=";
        PRESSANYKEY=    "Press any key";
        End;
/*--------------------End French translation strings------------------------------------*/

/*--------------------Start Finnish translation strings------------------------------------*/
When (Language="S") Then
        Do
        YES='K';
        NO='E';
        CANNOTSTARTNPS= "NPS WPS ohjelmaa ei voi aloittaa!";
        CREATING=               "Luodaan NPS WPS kansio ja objektit...";
        FILENOTFOUND=           "Tiedostoa NPSWPS.EXE ei lydy! Onko asennus suoritettu loppuun?"||,
                        " Voit yritt suorittaa"crlf"INSTALL.CMD komenotojonoa"||,
                        " asennushakemistosta ksin.";
        TITLE1=                 "NPS WPS Enhancer";
        TITLE2=                 "NPS WPS"crlf"Kyttopas";
        TITLE3=                 "Ikkuna-animaation"crlf"Kyttopas";
        TITLE4=                 "NPS WPS ohjelman poisto";
        FILE1=                  "LueMinut.1st";
        FILE2=                  "NPSWPSFI";
        NPSFOUND=               "NPS WPS kansio on jo olemassa."crlf||,
                        crlf"Jos et ole lisnnyt yhtn omaa objektia thn kansioon,"crlf||,
                        "niin kansio on turvallista poistaa"crlf"ja luoda uusi kansio (esim."||,
                        " jos haluat asetentaa toisen kielen, tai"crlf"asentaa NPS WPS ohjelman uudestaan."crlf||,
                        crlf"Poistetaanko kytss oleva kansio ja luodaan uusi? (K/E):";
        RUNNING=                "NPS WPS ohjelma on jo kynniss! NPS WPS Ohjelma tytyy sulkea "||,
                        "ensin ja suorittaa tmn jlkeen INSTALL.CMD uudestaan.";
        ASKDIR=         "NPS WPS ohjelman asennus hakemistoon. "||,
                        "Olet joko:"crlf||crlf||,
                        "- Asentamassa ohjelmaa levykkeelt tai CD-ROM levylt kiintolevylle tai"crlf||,
                        "  olet purkanut NPSWPS.ZIP paketin tilapiseen hakemistoon ja haluat"crlf||,
                        "  kytt NPS WPS ohjelmaa toisesta hakemistosta ksin, johon tiedostot"crlf||,
                        "  kopioidaan. Tss tapauksessa syt tydellinen polku hakemistoon, jota "crlf||,
                        "  haluat kytt. (Jos tt hakemistoa ei ole olemassa, se luodaan)."crlf||,
                        "  Esimerkki: "LGre"C:\NPSWPS"LWhi||crlf||crlf||,
                        "- Purkanut NPSWPS.ZIP paketin kiintolevylle hakemistoon, josta haluat kytt"crlf||,
                        "  NPS WPS ohjelmaa jatkossa. l syt hakemistoa, paina vain "LGre" Enter."||LWhi||,
                        crlf||crlf"Jos haluat keskeytt asennuksen, paina Ctrl+C ja Enter.";
        PROMPTDIR=              "Syt kohdehakemisto:";
        NOCREATEDIR=            ": Hakemistoa ei voi luoda. REXX: SysMkDir errorcode=";
        COPYFAILED=             "Tiedostoja ei voi kopioida. OS/2 error code=";
        PRESSANYKEY=            "Paina nppint";
        End;
/*-------------------End Finnish translation strings------------------------------------*/


Otherwise
/*--------------------Start English translation strings------------------------------------*/
        Do
        YES='Y';
        NO='N';
        CANNOTSTARTNPS= "Cannot start NPS WPS!";
        CREATING=       "Creating NPS WPS folder and objects...";
        FILENOTFOUND=   "NPSWPS.EXE not found! Are the installation files complete?"||,
                        " Otherwise, you could"crlf"try to run INSTALL.CMD from the"||,
                        " directory with the installation files.";
        TITLE1=         "NPS WPS Enhancer";
        TITLE2=         "NPS WPS"crlf"Documentation";
        TITLE3=         "Window Animation"crlf"Documentation";
        TITLE4=         "Uninstall NPS WPS";
        FILE1=          "ReadMe.1st";
        FILE2=          "NPSWPSUS";
        NPSFOUND=       "The NPS WPS folder does already exist."crlf||,
                        crlf"As long as you haven't created any objects in this folder, "||,
                        "it's safe to delete"crlf"this folder and rebuild a new one (for"||,
                        " instance, if you want to use another"crlf"language or just want to "||,
                        "create the NPS WPS objects again)."crlf||,
                        crlf"Shall I delete the folder and make a new one? (Y/N):";
        RUNNING=        "NPS WPS is already running at the moment! You have to close "||,
                        "NPS WPS first,"crlf"and then execute INSTALL.CMD again.";
        ASKDIR=         "NPS WPS is going to be installed to a directory. "||,
                        "Two situations are possible:"crlf||crlf||,
                        "- You are installing from diskette or CD-ROM to the harddisk."crlf||,
                        "  Or you have unzipped NPSWPS.ZIP to a temporary directory and wish"||,
                        " to use"crlf"  NPS WPS from another directory. The files will be "||,
                        "copied. Then please enter"crlf"  the full path to the directory "||,
                        "that you would like to use."crlf"  (If this directory doesn't exist "||,
                        "yet, it will be created)."crlf||,
                        "  Example: "LGre"C:\NPSWPS"LWhi||crlf||crlf||,
                        "- You have unzipped NPSWPS.ZIP to the directory on the harddisk "||,
                        "from which"crlf"  you want to use NPS WPS."||,
                        " Then don't enter a directory, but just "LGre"press Enter."||LWhi||,
                        crlf||crlf"Would you like to quit, press Ctrl-C, followed by Enter.";
        PROMPTDIR=      "Please enter destination directory:";
        NOCREATEDIR=    ": Could not create directory. REXX: SysMkDir errorcode=";
        COPYFAILED=     "Could not copy files. OS/2 error code=";
        PRESSANYKEY=    "Press any key";
        End;
/*-------------------End English translation strings------------------------------------*/
End;
Return;

/*--------------------------------------------------------------------------------------*\
 *                       Check if NPS WPS is already running                            *
 *                                                                                      *
\*--------------------------------------------------------------------------------------*/

CheckRunningOrIncomplete:

'Cls'
rc = stream('npswps.exe','c','query exists');
If rc = '' Then
Do
        Call Banner;
        Say FILENOTFOUND;
        Call GoodBye 1;
End;

"PSTAT /c |FIND /i /c ""npswps.exe"""
If SysTextScreenRead(0,0,1)="1" Then
        Do
        Call Banner;
        Say RUNNING;
        Say;
        Call GoodBye 1;
        End
Return;

/*--------------------------------------------------------------------------------------*\
 *                           Create a directory recursively                             *
 *       Don't look at this horrible Rexx code. I can't guarantee it actually works     *
 *                 in all cases... I hate that PC drive lettering scheme!               *
\*--------------------------------------------------------------------------------------*/

MakeDirectory:

Parse Arg pathtocreate;

subpath="";
failedpath="";
count = 0;
failure=0;
Do While pathtocreate\== ""
        PARSE VAR pathtocreate partofpath "\" pathtocreate;
        If count > 0 Then
                subpath=subpath||'\'||partofpath
        Else
                subpath=partofpath;
        If (subpath\="") & (\((count=0) & (Right(subpath,1)=':'))) Then
        Do
                rc=SysFileTree(subpath,dir_list, 'D');
                If (dir_list.0 = 0) Then
                Do
                        rc=SysMkdir(subpath);
                        If rc\=0 Then
                        Do
                                failure=1;
                                failedpath=subpath;
                        End
                        Else
                                failure=0
                End
        End
        count = count + 1;
End;
If failure=1 Then
Do
        Call GoodBye 2 failedpath rc
End;
Return;

/*--------------------------------------------------------------------------------------*\
 *           Routine to perform an OS/2 copy command and give a return code             *
\*--------------------------------------------------------------------------------------*/

CopyIt:

Parse Arg Source, Target;

Say crlf||LGre'Copy: 'Source' --> 'Target||LWhi
'COPY 'Source' 'Target
If rc\=0 Then
Do
        Say LRed||COPYFAILED||rc||crlf;
        Call GoodBye 1;
End;
Return;

/*--------------------------------------------------------------------------------------*\
 *                         Ask directory where NPS WPS should installed                 *
 *                           (optionally copy files to that location)                   *
\*--------------------------------------------------------------------------------------*/

SetupDestinationDir:

Call Banner;
Say ASKDIR||crlf;
Call charout ,PROMPTDIR" "LGre;
Pull DestinationDir;
DestinationDir=Strip(Strip(DestinationDir),"T","\");
If (DestinationDir="" | DestinationDir=SourceDir) Then
        /* Just an Enter means: install in here */
        DestinationDir=SourceDir
Else Do
        Call MakeDirectory DestinationDir;
        Call Banner;
        Do i = 2 to NPSBase.1
                Call CopyIt SourceDir'\'NPSBase.i' ', DestinationDir;
        End
        Call CopyIt SourceDir'\'FILE2'*.* ', DestinationDir;
        Call CopyIt SourceDir'\INSTALL.* ', DestinationDir;
        Call CopyIt SourceDir'\UNINSTAL.* ', DestinationDir;
        Call CopyIt SourceDir'\mutchwa2.dll ', DestinationDir;
        Call CopyIt SourceDir'\CB_BMPS.ZIP ', DestinationDir;
        Call CopyIt SourceDir'\'FILE1' ', DestinationDir;
        Call CopyIt SourceDir'\Wishlist.txt ', DestinationDir;
End;
rc=Directory(DestinationDir);
/* If the files are copied from CD-ROM they may have the read-only attribute on.
   We've got to remove these or else the user cannot uninstall. */
'ATTRIB -R *.*  1>NUL 2>NUL'
Return;

/*--------------------------------------------------------------------------------------*\
 *                         Create NPS WPS objects                                       *
 *                                                                                      *
\*--------------------------------------------------------------------------------------*/

CreateObjects:

classname = 'WPFolder';
location = '<WP_DESKTOP>';
setup = 'OBJECTID=<NPSWPS_Folder>;OPEN=DEFAULT;';
result=SysCreateObject(classname,TITLE1,location,setup,f);

YesNo=NO;
If result = 0 Then
Do
        Do Until (YesNo=YES)
                Call Banner;
                Call charout ,NPSFOUND" ";
                YesNo=getUserInput(YES||NO);
                If (YesNo=NO) Then Call GoodBye 1;
                Say;
        End
        Call SysDestroyObject "<NPSWPS_Folder>";
        result=SysCreateObject(classname,TITLE1,location,setup,f);
End;

Say CREATING;

classname = 'WPProgram';
location = '<NPSWPS_Folder>';
setup = 'EXENAME='DestinationDir'\NPSWPS.EXE;STARTUPDIR='DestinationDir';OBJECTID=<NPSWPS>;';
If existed = '' Then setup = setup';PARAMETERS=%*;';
Call SysCreateObject classname,TITLE1,location,setup,u;

/* create shadow for NPSWPS.EXE in the Startup folder */
classname = 'WPShadow';
location = '<WP_START>';
setup = 'SHADOWID=<NPSWPS>;';
Call SysCreateObject classname,TITLE1,location,setup,u;

rc = stream(FILE1,'c','query exists');
If rc \= '' Then
Do
        classname = 'WPProgram';
        location = '<NPSWPS_Folder>';
        setup = 'PARAMETERS='DestinationDir'\'FILE1';EXENAME=E.EXE;';
        Call SysCreateObject classname,FILE1,location,setup,u;
End;

rc = stream(FILE2'.INF','c','query exists');
If rc \= '' Then
Do
        classname = 'WPProgram';
        location = '<NPSWPS_Folder>';
        setup = 'OBJECTID=<NPSMANUAL>;PARAMETERS='DestinationDir'\'FILE2'.INF;EXENAME=VIEW.EXE;';
        Call SysCreateObject classname,TITLE2,location,setup,u;
End;

rc = stream('NPSWPSWA.Doc','c','query exists');
If rc \= '' Then
Do
        classname = 'WPProgram';
        location = '<NPSWPS_Folder>';
        setup = 'OBJECTID=<NPSWAMANUAL>;EXENAME=E.EXE;PARAMETERS='DestinationDir'\NPSWPSWA.DOC;';
        Call SysCreateObject classname,TITLE3,location,setup,u;
End;

rc = stream('UNINSTAL.CMD','c','query exists');
If rc \= '' Then;
Do
        classname = 'WPProgram';
        location = '<NPSWPS_Folder>';
        setup = 'ICONFILE='DestinationDir'\UNINSTAL.ICO;STARTUPDIR='||,
                DestinationDir';EXENAME=CMD.EXE;'||,
                'PARAMETERS=/C 'DestinationDir'\UNINSTAL.CMD /STARTEDFROMWPS;';
        Call SysCreateObject classname,TITLE4,location,setup,u;
End;

rc = stream('README','c','query exists');
If rc \= '' Then
Do
  TITLE = "ReadMe";
  classname = 'WPShadow';
  location = '<NPSWPS_Folder>';
  setup = 'SHADOWID='rc';';
  Call SysCreateObject classname,TITLE,location,setup,u;
End;

rc = stream('NPSWPS.INI','c','query exists');
If rc \= '' Then
        Do
        rc=SysIni("NPSWPS.INI","NPS WPS Enhancer","Language",Language);
        End;
Return;

/*--------------------------------------------------------------------------------------*\
 * Compile the correct resource file so that the NPS WPS executable is using the        *
 * language the user wanted. Also finish with some information on screen.               *
\*--------------------------------------------------------------------------------------*/

CompileRC_AndFinish:

Say;
Select
When (Language="D")
        Then Do
        Call CopyIt NPSWPSDE.LST, NPSWPS.LST
        "RC NPSWPSDE.RC NPSWPS.DLL"
        If rc\=0 Then
                Do
                Say crlf"Die deutschsprachigen Texte knnen nicht compiliert werden.";
                Say "Sie mssen NPS WPS erst beenden, bevor Sie INSTALL.CMD erneut starten.";
                Call GoodBye 1;
                End
        Else
                Do
                Call Banner;
                Say crlf"Fertig."crlf;
                Say "Im Systemstart-Ordner wurde eine Referenz auf NPSWPS.EXE angelegt. NPS WPS ist";
                Say "jetzt aktiv. Um die Konfiguration zu ndern, knnen Sie Strg-Esc drcken,";
                Say 'mit den Cursor-Tasten "NPS WPS Enhancer" whlen und dann auf Enter drcken.';
                Say "Um NPS WPS zu lschen, mssen Sie NPS WPS erst beenden. Dann ";
                Say 'knnen auf das Icon "'TITLE4'" im NPS WPS Ordner doppelklicken.'crlf;
                Say "Herzlichen Glckwunsch! Sie haben soeben NPS WPS installiert!";
                End
  End
  When (Language="N")
        Then Do
        Call CopyIt NPSWPSNL.LST, NPSWPS.LST
        "RC NPSWPSNL.RC NPSWPS.DLL"
        If rc\=0 Then
                Do
                Say crlf"Kan taalstrings niet compileren! U moet NPS WPS eerst afsluiten voordat u",
                        crlf"INSTALL.CMD opnieuw opstart. Of x:\OS2\RC.EXE bestaat niet",
                        " (zie NPS WPS"crlf"documentatie).";
                Call GoodBye 1;
                End
        Else
                Do
                Call Banner;
                Say crlf"Klaar."crlf;
                Say "Er is een reflectie gemaakt in de Opstarten map. Ik heb NPS WPS ook meteen";
                Say "voor u opgestart zodat u het meteen kunt gebruiken. Om de instellingen";
                Say "te veranderen drukt u op Ctrl-Esc, kiest u met de pijltjestoetsen";
                Say '"NPS WPS Enhancer" en drukt dan op Enter.'crlf;
                Say "Om NPS WPS te verwijderen moet u alle NPS WPS eerst afsluiten. Daarna";
                Say 'dubbelklikt u op het pictogram "'TITLE4'" dat zich in';
                Say "de NPS WPS map bevindt."crlf;
                Say "Gefeliciteerd! U heeft zojuist NPS WPS genstalleerd!";
                End
      End
  When (Language="I")
    Then Do
        Call CopyIt NPSWPSIT.LST, NPSWPS.LST
        "RC NPSWPSIT.RC NPSWPS.DLL"
        If rc\=0 Then
                Do
                Say crlf"Cannot compile language strings!"crlf"You have to close NPS WPS before you",
                        " start INSTALL.CMD again."crlf"Or x:\OS2\RC.EXE is not present",
                        " (see NPS WPS documentation).";
                Call GoodBye 1;
                End
        Else
                Do
                Call Banner;
                Say crlf"O.K."crlf;
                Say "A shadow has been made in the Startup folder. I have started NPS WPS";
                Say "for you so that you can use it right away. To configure NPS WPS";
                Say "you have to press Ctrl-Esc, use the cursorkeys to go to";
                Say '"NPS WPS Enhancer" and then press Enter.'crlf;
                Say "To remove NPS WPS, make sure it is not running. Then double-click";
                Say 'on the icon "'TITLE4'" located in the NPS WPS folder.'crlf;
                Say "Congratulations, you have just installed NPS WPS!";
                        End
  End
  When (Language="F")
    Then Do
        Call CopyIt NPSWPSFR.LST, NPSWPS.LST
        "RC NPSWPSFR.RC NPSWPS.DLL"
        if rc\=0 Then
                Do
                Say crlf"Cannot compile language strings!"crlf"You have to close NPS WPS before you",
                        " start INSTALL.CMD again."crlf"Or x:\OS2\RC.EXE is not present",
                        " (see NPS WPS documentation).";
                Call GoodBye 1;
                End
        Else
                Do
                Call Banner;
                Say crlf"O.K."crlf;
                Say "A shadow has been made in the Startup folder. I have started NPS WPS";
                Say "for you so that you can use it right away. To configure NPS WPS";
                Say "you have to press Ctrl-Esc, use the cursorkeys to go to";
                Say '"NPS WPS Enhancer" and then press Enter.'crlf;
                Say "To remove NPS WPS, make sure it is not running. Then double-click";
                Say 'on the icon "'TITLE4'" located in the NPS WPS folder.'crlf;
                Say "Congratulations, you have just installed NPS WPS!";
                End
  End

  When (Language="S")
    Then Do
        Call CopyIt NPSWPSFI.LST, NPSWPS.LST
        "RC NPSWPSFI.RC NPSWPS.DLL"
        if rc\=0 Then
                Do
                Say crlf"Suomenkielisi merkkijonoja ei voi asentaa!"crlf"Sulje NPS WPS ohjelma",
                        " ja kynnist INSTALL.CMD uudestaan.";
                Call GoodBye 1;
                End
        Else
                Do
                Call Banner;
                Say crlf"O.K."crlf;
                Say "Ohjelman varjo on sijoitettu Aloitus -kansioon. NPS WPS ohjelma on";
                Say "kynniss. Muuttaaksesi NPS WPS ohjelman asetuksia,";
                Say 'paina Ctrl-Esc ja kaksoisnapsauta "NPS WPS Enhancer" rivi.'crlf;
                Say "Poistaaksesi NPS WPS ohjelman, varmista ettei se ole kynniss.";
                Say 'Tmn jlkeen kaksoisnapsauta "'TITLE4'" -kuvaketta';
	  Say 'NPS WPS kansiosta.'crlf;
                Say "Onneksi olkoon, olet juuri asentanut NPS WPS ohjelman!";
                End
  End

Otherwise
        If (Language="J") Then
                Do
                Call CopyIt NPSWPSJP.LST, NPSWPS.LST
                "RC NPSWPSJP.RC NPSWPS.DLL"
                End
        Else
                Do
                Call CopyIt NPSWPSUS.LST, NPSWPS.LST
                "RC NPSWPSUS.RC NPSWPS.DLL"
                End
        If rc\=0 Then
                Do
                Say crlf"Cannot compile language strings!"crlf"You have to close NPS WPS before you",
                        " start INSTALL.CMD again."crlf"Or x:\OS2\RC.EXE is not present",
                        " (see NPS WPS documentation).";
                If (Language='J') Then
                        Say "Also, you must be using the Japanese version of OS/2.";
                Call GoodBye 1;
                End
        Else
                Do
                Call Banner;
                Say crlf"O.K."crlf;
                Say "A shadow has been made in the Startup folder. I have started NPS WPS";
                Say "for you so that you can use it right away. To configure NPS WPS";
                Say "you have to press Ctrl-Esc, use the cursorkeys to go to";
                Say '"NPS WPS Enhancer" and then press Enter.'crlf;
                Say "To remove NPS WPS, make sure it is not running. Then double-click";
                Say 'on the icon "'TITLE4'" located in the NPS WPS folder.'crlf;
                Say "Congratulations, you have just installed NPS WPS!";
                End
End;

/* Now we can start NPS WPS as a service to the user :-) */
rc=SysSetObjectData("<NPSWPS>","OPEN=DEFAULT");
If (rc=0) Then
Do
        Say LRed||CANNOTSTARTNPS||crlf;
End
Return;

/*--------------------------------------------------------------------------------------*\
 *                   Clean up and exit gracefully                                       *
 *                                                                                      *
\*--------------------------------------------------------------------------------------*/

GoodBye:

Parse Arg ExitCode ErrorPath ErrorCode;

If ((ExitCode=1) | (ExitCode=2)) Then
Do
        If (ExitCode=2) Then
        Do
                Say LRed||ErrorPath||NOCREATEDIR||ErrorCode;
        End
        Say LWhi||PRESSANYKEY;
        rc=SysGetKey('NOECHO');
End;
Say LWhi;
rc=Directory('\');
InvokeDir=Directory(InvokeDir);
Exit;

/*--------------------------------------------------------------------------------------*\
 *    No REXX-support? We must be using OS/2 2.x, REXX has to be installed by user      *
 *                                                                                      *
\*--------------------------------------------------------------------------------------*/

:NoRexx

@Echo Off
Echo FATAL ERROR: No REXX-support has been installed. Please use
Echo "Selective Install" in the "System" folder to install REXX.
Echo --------------------------------------------------------------
Echo PROBLEEM: REXX-ondersteuning is niet genstalleerd. Gebruik
Echo "Onderdelen Installeren" in de map "Systeem" om REXX te
Echo installeren
Echo --------------------------------------------------------------
Echo FEHLER: Die REXX-Untersttzung ist nicht vorhanden.
Echo benutzen Sie "Installation anpassen" im Ordner
Echo "Systemkonfiguration" um REXX zu installieren.
Echo --------------------------------------------------------------
Echo VIRHE: REXX -tukea ei ole asennettu. Kyt "Jrjestelmn asetukset"
Echo kansiosta lytyv "Valikoiva asennus" ohjelmaa asentaaksesi
Eche REXX tuen.
Echo --------------------------------------------------------------

Pause
